// ************************************************
// подпрограммы работы с моторами
// ************************************************

// инициализация моторов
void ini_motors() {
  pinMode(MOTOR_LEFT1,OUTPUT);
  pinMode(MOTOR_LEFT2,OUTPUT);
  pinMode(MOTOR_LEFTPWM,OUTPUT);
  pinMode(MOTOR_RIGHT1,OUTPUT);
  pinMode(MOTOR_RIGHT2,OUTPUT);
  pinMode(MOTOR_RIGHTPWM,OUTPUT);
}

// движение робота
void set_motors(int left1,int left2,int leftpwm,int right1,int right2,int rightpwm) {
   digitalWrite(MOTOR_LEFT1,left1);
   digitalWrite(MOTOR_LEFT2,left2);
   analogWrite(MOTOR_LEFTPWM,leftpwm);
   digitalWrite(MOTOR_RIGHT1,right1);
   digitalWrite(MOTOR_RIGHT2,right2);
   analogWrite(MOTOR_RIGHTPWM,rightpwm);
}
// вперед 
void forward() {
   MOVE1.left1=1;
   MOVE1.left2=0;
   MOVE1.right1=1;
   MOVE1.right2=0; 
   MOVE1.leftpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
   MOVE1.rightpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
}
// назад 
void backward() {
   MOVE1.left1=0;
   MOVE1.left2=1;
   MOVE1.right1=0;
   MOVE1.right2=1;   
   MOVE1.leftpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
   MOVE1.rightpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
}
// стоп
void stop() {
   MOVE1.left1=0;
   MOVE1.left2=0;
   MOVE1.right1=0;
   MOVE1.right2=0;   
   MOVE1.leftpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
   MOVE1.rightpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
}
// влево 
void left() {
   MOVE1.left1=0;
   MOVE1.left2=1;
   MOVE1.right1=1;
   MOVE1.right2=0;   
   MOVE1.leftpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
   MOVE1.rightpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
}
// вправо 
void right() {
   MOVE1.left1=1;
   MOVE1.left2=0;
   MOVE1.right1=0;
   MOVE1.right2=1;   
   MOVE1.leftpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
   MOVE1.rightpwm=max(MOVE1.leftpwm,MOVE1.rightpwm);
}
// установить скорость
void setspeed(int lpwm,int rpwm) {
   MOVE1.leftpwm=lpwm;
   MOVE1.rightpwm=rpwm; 
}
// вперед и вправо 
void forward_right() {
   MOVE1.left1=1;
   MOVE1.left2=0;
   MOVE1.right1=1;
   MOVE1.right2=0; 
   if(MOVE1.leftpwm < MOVE1.rightpwm) 
     {
      MOVE1.leftpwm=MOVE1.rightpwm+D_SPEED;
      if(MOVE1.leftpwm>255)
        {
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
        }
     }
   else
     {
      MOVE1.leftpwm=MOVE1.leftpwm+D_SPEED;
      if(MOVE1.leftpwm>255)
        {
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
         if(MOVE1.rightpwm<0)
            MOVE1.rightpwm=0;
        }
     }       
}
// вперед и влево 
void forward_left() {
   MOVE1.left1=1;
   MOVE1.left2=0;
   MOVE1.right1=1;
   MOVE1.right2=0; 
   if(MOVE1.rightpwm < MOVE1.leftpwm) 
     {
      MOVE1.rightpwm=MOVE1.rightpwm+D_SPEED;
      if(MOVE1.rightpwm>255)
        {
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
        }
     }
   else
     {
      MOVE1.rightpwm=MOVE1.rightpwm+D_SPEED;
      if(MOVE1.rightpwm>255)
        {
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
         if(MOVE1.leftpwm<0)
            MOVE1.leftpwm=0;
        }
     }       
}

// назад и вправо 
void backward_right() {
   MOVE1.left1=0;
   MOVE1.left2=1;
   MOVE1.right1=0;
   MOVE1.right2=1; 
   if(MOVE1.leftpwm < MOVE1.rightpwm) 
     {
      MOVE1.leftpwm=MOVE1.rightpwm+D_SPEED;
      if(MOVE1.leftpwm>255)
        {
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
        }
     }
   else
     {
      MOVE1.leftpwm=MOVE1.leftpwm+D_SPEED;
      if(MOVE1.leftpwm>255)
        {
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
         if(MOVE1.rightpwm<0)
            MOVE1.rightpwm=0;
        }
     }       
}
// назад и влево 
void backward_left() {
   MOVE1.left1=0;
   MOVE1.left2=1;
   MOVE1.right1=0;
   MOVE1.right2=1; 
   if(MOVE1.rightpwm < MOVE1.leftpwm) 
     {
      MOVE1.rightpwm=MOVE1.rightpwm+D_SPEED;
      if(MOVE1.rightpwm>255)
        {
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
        }
     }
   else
     {
      MOVE1.rightpwm=MOVE1.rightpwm+D_SPEED;
      if(MOVE1.rightpwm>255)
        {
         MOVE1.rightpwm=MOVE1.rightpwm-D_SPEED;
         MOVE1.leftpwm=MOVE1.leftpwm-D_SPEED;
         if(MOVE1.leftpwm<0)
            MOVE1.leftpwm=0;
        }
     }       
}
